import aiosched
from wait import child
from debugger import Debugger


async def main(children: list[tuple[str, int]]):
    print("[main] Spawning children")
    async with aiosched.with_context() as ctx:
        for name, delay in children:
            await ctx.spawn(child, name, delay)
        print(f"[main] Spawned {len(ctx.tasks)} children")
        before = aiosched.clock()
    print(f"[main] Children exited in {aiosched.clock() - before:.2f} seconds")


if __name__ == "__main__":
    aiosched.run(main, [("first", 1), ("second", 2), ("third", 3)], debugger=None)
